﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x404

namespace i8028UW_Basic_Info_Csharp
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Int16 slot = 0;
        public MainPage()
        {
            this.InitializeComponent();
            Library_ver_txt.Text = String.Format("{0:X4}", pac_i8028UNet.pac8028U.LibVersion());
            Library_date_txt.Text = pac_i8028UNet.pac8028U.LibDate();
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Int16 FW = 0;
            slot = (Int16)slot_cbx.SelectedIndex;
            if (pac_i8028UNet.pac8028U.Init(slot) == 0)
            {
                pac_i8028UNet.pac8028U.FirmwareVersion(slot, ref FW);
                FW_ver_txt.Text = String.Format("{0:X4}", FW);
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void Fun_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            switch (Fun_cbx.SelectedIndex)
            {
                case 0:
                    {
                        grid_fm.Navigate(typeof(Pages.AO_Output), slot);
                        break;
                    }
                case 1:
                    {
                        grid_fm.Navigate(typeof(Pages.Powerr_on), slot);
                        break;
                    }
                case 2:
                    {
                        grid_fm.Navigate(typeof(Pages.Safe_value), slot);
                        break;
                    }
                default:
                    {
                        break;
                    }
            }
        }

        private void Exit_btn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }
    }
}