﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8028UW_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class AO_Output : Page
    {
        Int16 slot = 0;
        ComboBox[] range_cbx;
        TextBox[] gain_txt;
        TextBox[] offset_txt;
        TextBox[] data_txt;
        public AO_Output()
        {
            this.InitializeComponent();
            range_cbx = new ComboBox[8] { R0_cbx, R1_cbx, R2_cbx, R3_cbx, R4_cbx, R5_cbx, R6_cbx, R7_cbx };
            gain_txt = new TextBox[8] { G0_txt, G1_txt, G2_txt, G3_txt, G4_txt, G5_txt, G6_txt, G7_txt };
            offset_txt = new TextBox[8] { O0_txt, O1_txt, O2_txt, O3_txt, O4_txt, O5_txt, O6_txt, O7_txt };
            data_txt = new TextBox[8] { D0_txt, D1_txt, D2_txt, D3_txt, D4_txt, D5_txt, D6_txt, D7_txt };
        }
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            
            base.OnNavigatedTo(e);
            slot =(Int16)e.Parameter;
        }

        private void Range_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Int16 ch = 0;
            Int16 gain = 0;
            UInt16 gval = 0;
            Int16 oval = 0;
            ComboBox cbx = sender as ComboBox;
            switch (cbx.Name)
            {
                case "R0_cbx":
                    {
                        ch = 0;
                        break;
                    }
                case "R1_cbx":
                    {
                        ch = 1;
                        break;
                    }
                case "R2_cbx":
                    {
                        ch = 2;
                        break;
                    }
                case "R3_cbx":
                    {
                        ch = 3;
                        break;
                    }
                case "R4_cbx":
                    {
                        ch = 4;
                        break;
                    }
                case "R5_cbx":
                    {
                        ch = 5;
                        break;
                    }
                case "R6_cbx":
                    {
                        ch = 6;
                        break;
                    }
                case "R7_cbx":
                    {
                        ch = 7;
                        break;
                    }
            }
            gain = (Int16)cbx.SelectedIndex;
            pac_i8028UNet.pac8028U.ReadGainOffset(slot,ch, gain, ref gval, ref oval);
            gain_txt[ch].Text = gval.ToString();
            offset_txt[ch].Text = oval.ToString();
        }

        private void Set_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 ch = 0;
            Button cbx = sender as Button;
            switch (cbx.Name)
            {
                case "O0_btn":
                    {
                        ch = 0;
                        break;
                    }
                case "O1_btn":
                    {
                        ch = 1;
                        break;
                    }
                case "O2_btn":
                    {
                        ch = 2;
                        break;
                    }
                case "O3_btn":
                    {
                        ch = 3;
                        break;
                    }
                case "O4_btn":
                    {
                        ch = 4;
                        break;
                    }
                case "O5_btn":
                    {
                        ch = 5;
                        break;
                    }
                case "O6_btn":
                    {
                        ch = 6;
                        break;
                    }
                case "O7_btn":
                    {
                        ch = 7;
                        break;
                    }
            }
            pac_i8028UNet.pac8028U.WriteAO(slot,ch,(Int16)range_cbx[ch].SelectedIndex,float.Parse(data_txt[ch].Text));
        }
    }
}
