﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace pac_i8028UNet
{
    public class pac8028U
    {
        private const string lib = "pac_i8028U_UWP_x64.dll";
        private class ICPDAS
        {
            [DllImport(lib, EntryPoint = "pac_i8028U_GetLibVersion")]
            public static extern Int16 pac_i8028U_GetLibVersion();
            [DllImport(lib, EntryPoint = "pac_i8028U_GetLibDate")]
            public static extern void pac_i8028U_GetLibDate(byte[] libDate);
            [DllImport(lib, EntryPoint = "pac_i8028U_GetFirmwareVersion")]
            public static extern Int16 pac_i8028U_GetFirmwareVersion(int slot, ref Int16 ver);
            [DllImport(lib, EntryPoint = "pac_i8028U_Init")]
            public static extern Int16 pac_i8028U_Init(int slot);
            [DllImport(lib, EntryPoint = "pac_i8028U_GetModuleLastOutputStatus")]
            public static extern Int16 pac_i8028U_GetModuleLastOutputStatus(int slot);
            [DllImport(lib, EntryPoint = "pac_i8028U_SetPowerOnEnStatus")]
            public static extern Int16 pac_i8028U_SetPowerOnEnStatus(int slot, Int16 status);
            [DllImport(lib, EntryPoint = "pac_i8028U_GetPowerOnEnStatus")]
            public static extern Int16 pac_i8028U_GetPowerOnEnStatus(int slot, ref Int16 status);
            [DllImport(lib, EntryPoint = "pac_i8028U_WriteAO")]
            public static extern Int16 pac_i8028U_WriteAO(int slot, int ch, Int16 gain, float aoData);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadAO")]
            public static extern void pac_i8028U_ReadAO(int slot, int ch, ref Int16 gain, ref float aoData);
            [DllImport(lib, EntryPoint = "pac_i8028U_WritePowerOn_AO")]
            public static extern Int16 pac_i8028U_WritePowerOn_AO(int slot, int ch, Int16 gain, float aoData);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadPowerOn_AO")]
            public static extern void pac_i8028U_ReadPowerOn_AO(int slot, int ch, ref Int16 gain, ref float aoData);
            [DllImport(lib, EntryPoint = "pac_i8028U_WriteSafe_AO")]
            public static extern Int16 pac_i8028U_WriteSafe_AO(int slot, int ch, Int16 gain, float aoData);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadSafe_AO")]
            public static extern void pac_i8028U_ReadSafe_AO(int slot, int ch, ref Int16 gain, ref float aoData);
            [DllImport(lib, EntryPoint = "pac_i8028U_WriteAOHex")]
            public static extern Int16 pac_i8028U_WriteAOHex(int slot, int ch, Int16 gain, Int16 aoHex);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadAOHex")]
            public static extern void pac_i8028U_ReadAOHex(int slot, int ch, ref Int16 gain, ref Int16 aoHex);
            [DllImport(lib, EntryPoint = "pac_i8028U_WritePowerOnHex_AO")]
            public static extern Int16 pac_i8028U_WritePowerOnHex_AO(int slot, int ch, Int16 gain, Int16 aoHex);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadPowerOnHex_AO")]
            public static extern void pac_i8028U_ReadPowerOnHex_AO(int slot, int ch, ref Int16 gain, ref Int16 aoHex);
            [DllImport(lib, EntryPoint = "pac_i8028U_WriteSafeHex_AO")]
            public static extern Int16 pac_i8028U_WriteSafeHex_AO(int slot, int ch, Int16 gain, Int16 aoHex);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadSafeHex_AO")]
            public static extern void pac_i8028U_ReadSafeHex_AO(int slot, int ch, ref Int16 gain, ref Int16 aoHex);
            [DllImport(lib, EntryPoint = "pac_i8028U_FRAM_WriteByte")]
            public static extern Int16 pac_i8028U_FRAM_WriteByte(int slot, int block, int address, byte data);
            [DllImport(lib, EntryPoint = "pac_i8028U_FRAM_ReadByte")]
            public static extern Int16 pac_i8028U_FRAM_ReadByte(int slot, int block, int address, ref byte data);
            [DllImport(lib, EntryPoint = "pac_i8028U_GetModuleWDTStatus")]
            public static extern Int16 pac_i8028U_GetModuleWDTStatus(int slot);
            [DllImport(lib, EntryPoint = "pac_i8028U_GetModuleWDTConfig")]
            public static extern Int16 pac_i8028U_GetModuleWDTConfig(int slot, ref Int16 enStatus, ref UInt32 wdtTimeout, ref Int32 ifWDT_Overwrite);
            [DllImport(lib, EntryPoint = "pac_i8028U_SetModuleWDTConfig")]
            public static extern Int16 pac_i8028U_SetModuleWDTConfig(int slot, Int16 enStatus, UInt32 wdtTimeout, Int32 ifWDT_Overwrite);
            [DllImport(lib, EntryPoint = "pac_i8028U_ResetModuleWDT")]
            public static extern void pac_i8028U_ResetModuleWDT(int slot);
            [DllImport(lib, EntryPoint = "pac_i8028U_RefreshModuleWDT")]
            public static extern void pac_i8028U_RefreshModuleWDT(int slot);
            [DllImport(lib, EntryPoint = "pac_i8028U_ReadAO_GainOffset")]
            public static extern void pac_i8028U_ReadAO_GainOffset(int slot, int ch, Int16 gain, ref UInt16 gVal, ref Int16 oVal);
        }
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8028U_GetLibVersion();
        }
        public static Int16 FirmwareVersion(int slot, ref Int16 firmware)
        {
            return ICPDAS.pac_i8028U_GetFirmwareVersion(slot, ref firmware);
        }
        public static string LibDate()
        {
            byte[] libDate = new byte[32];
            ICPDAS.pac_i8028U_GetLibDate(libDate);
            return AscArr2Str(libDate);
        }
        public static Int16 Init(int slot)
        {
            return ICPDAS.pac_i8028U_Init(slot);
        }
        public static Int16 LastOutputStatus(int slot)
        {
            return ICPDAS.pac_i8028U_GetModuleLastOutputStatus(slot);
        }
        public static Int16 SetPowerOnEnableStatus(int slot, Int16 powerType)
        {
            return ICPDAS.pac_i8028U_SetPowerOnEnStatus(slot, powerType);
        }
        public static Int16 GetPowerOnEnableStatus(int slot, ref Int16 powerType)
        {
            return ICPDAS.pac_i8028U_GetPowerOnEnStatus(slot, ref powerType);
        }
        public static Int16 WritePowerOn_AO(int slot, int ch, Int16 gain, float aoData)
        {
            return ICPDAS.pac_i8028U_WritePowerOn_AO(slot, ch, gain, aoData);
        }
        public static void ReadPowerOn_AO(int slot, int ch, ref Int16 gain, ref float aoData)
        {
            ICPDAS.pac_i8028U_ReadPowerOn_AO(slot, ch, ref  gain, ref  aoData);
        }
        public static Int16 WriteSafe_AO(int slot, int ch, Int16 gain, float aoData)
        {
            return ICPDAS.pac_i8028U_WriteSafe_AO(slot, ch, gain, aoData);
        }
        public static void ReadSafe_AO(int slot, int ch, ref Int16 gain, ref float aoData)
        {
            ICPDAS.pac_i8028U_ReadSafe_AO(slot, ch, ref  gain, ref  aoData);
        }
        public static Int16 WritePowerOnHex_AO(int slot, int ch, Int16 gain, Int16 hVal)
        {
            return ICPDAS.pac_i8028U_WritePowerOnHex_AO(slot, ch, gain, hVal);
        }
        public static void ReadPowerOnHex_AO(int slot, int ch, ref Int16 gain, ref Int16 hVal)
        {
            ICPDAS.pac_i8028U_ReadPowerOnHex_AO(slot, ch, ref  gain, ref  hVal);
        }
        public static Int16 WriteSafeHex_AO(int slot, int ch, Int16 gain, Int16 fVal)
        {
            return ICPDAS.pac_i8028U_WriteSafeHex_AO(slot, ch, gain, fVal);
        }
        public static void ReadSafeHex_AO(int slot, int ch, ref Int16 gain, ref Int16 fVal)
        {
            ICPDAS.pac_i8028U_ReadSafeHex_AO(slot, ch, ref  gain, ref  fVal);
        }
        public static Int16 SetModuleWDTConfig(int slot, Int16 enStatus, UInt32 wdtTimeout, Int32 ifWDT_Overwrite)
        {
            return ICPDAS.pac_i8028U_SetModuleWDTConfig(slot, enStatus, wdtTimeout, ifWDT_Overwrite);
        }
        public static Int16 GetModuleWDTConfig(int slot, ref Int16 enStatus, ref UInt32 wdtTimeout, ref Int32 ifWDT_Overwrite)
        {
            return ICPDAS.pac_i8028U_GetModuleWDTConfig(slot, ref  enStatus, ref  wdtTimeout, ref ifWDT_Overwrite);
        }
        public static Int16 IsWDTTimeout(int slot)
        {
            return ICPDAS.pac_i8028U_GetModuleWDTStatus(slot);
        }
        public static void RefreshWDT(int slot)
        {
            ICPDAS.pac_i8028U_RefreshModuleWDT(slot);
        }
        public static void ResetWDT(int slot)
        {
            ICPDAS.pac_i8028U_ResetModuleWDT(slot);
        }
        public static Int16 WriteAO(int slot, int ch, Int16 gain, float aoData)
        {
            return ICPDAS.pac_i8028U_WriteAO(slot, ch, gain, aoData);
        }
        public static void ReadAO(int slot, int ch, ref Int16 gain, ref float aoData)
        {
            ICPDAS.pac_i8028U_ReadAO(slot, ch, ref gain, ref aoData);
        }
        public static Int16 WriteAOHex(int slot, int ch, Int16 gain, Int16 aoHex)
        {
            return ICPDAS.pac_i8028U_WriteAOHex(slot, ch, gain, aoHex);
        }
        public static void ReadAOHex(int slot, int ch, ref Int16 gain, ref Int16 aoHex)
        {
            ICPDAS.pac_i8028U_ReadAOHex(slot, ch, ref gain, ref aoHex);
        }
        public static void ReadGainOffset(int slot, int ch, Int16 gain, ref UInt16 gVal, ref Int16 oVal)
        {
            ICPDAS.pac_i8028U_ReadAO_GainOffset(slot, ch, gain, ref gVal, ref oVal);
        }
        public static Int16 FRAM_WriteByte(int slot, int block, int address, byte data)
        {
            return ICPDAS.pac_i8028U_FRAM_WriteByte(slot, block, address, data);
        }
        public static Int16 FRAM_ReadByte(int slot, int block, int address, ref byte data)
        {
            return ICPDAS.pac_i8028U_FRAM_ReadByte(slot, block, address, ref data);
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }
    }
}